// period of pulse accumulation and serial output, milliseconds
#define MainPeriod 100
#define IN1 8
#define IN2 7
#define LEDgreen 4
#define LEDred 12
#include<AcceleroMMA7361.h>
long previousMillis = 0; // will store last time of the cycle end
volatile unsigned long duration=0; // accumulates pulse width
volatile unsigned int pulsecount=0;
volatile unsigned long previousMicros=0;
int pin = 11;
AcceleroMMA7361 accelero;
int x;
int y;
int z;

void setup()
{
  Serial.begin(9600); 
  attachInterrupt(0, myinthandler, RISING);
  pinMode(pin, OUTPUT);
  pinMode(IN1, OUTPUT);
  pinMode(IN2, OUTPUT);
  pinMode(LEDgreen, OUTPUT);
  pinMode(LEDred, OUTPUT);
  accelero.begin(13, 9, 11, 10, A0, A1, A2);
  accelero.setARefVoltage(5);
  accelero.setSensitivity(LOW);
  accelero.calibrate();
}

void loop()
{
  //Step 1: read frequency
  unsigned long currentMillis = millis();
  if (currentMillis - previousMillis >= MainPeriod) 
  {
    previousMillis = currentMillis;   
    // need to bufferize to avoid glitches
    unsigned long _duration = duration;
    unsigned long _pulsecount = pulsecount;
    duration = 0; // clear counters
    pulsecount = 0;
    float Freq = 1e6 / float(_duration);
    Freq *= _pulsecount; // calculate F
    //Serial.print("\t");
    //Serial.println(Freq);
    //Serial.print("\t");
    
    //Step 2:Condition
    if (Freq < 3100)
    {
      //Step 3: generate random values
      long randVal = random(1400, 2200);
      delay(1000);

      //Step 4: condition
      if (randVal > 1500)
      {
        //Step 5:active pin as random value OUTPUT
        //Step 6: set pin OUTPUT with random values 
        tone(pin, randVal);
        Serial.println("\t");
        Serial.println(randVal);
        Serial.println("\t");
        Serial.println("DONE");
        delay(1000);
        //Step 7: active Relay 
        digitalWrite(IN1, HIGH);
        delay(1000);
        digitalWrite(LEDgreen,HIGH);
        x = accelero.getXAccel();
        y = accelero.getYAccel();
        z = accelero.getZAccel();
        Serial.print("\nx: ");
        Serial.print(x);
        Serial.print("\ty; ");
        Serial.print(y);
        Serial.print("\tz: ");
        Serial.print(z);
        Serial.print("\tG*10^-2");
        delay(200);
        //delay(10000);
        //digitalWrite(LEDgreen, LOW);
        //delay(1000);
        //digitalWrite(IN2,HIGH);
        //delay(1000);
        //digitalWrite(IN2, LOW);
        //delay(1000);
        //digitalWrite(LEDred, HIGH);
        //delay(1000);
        //digitalWrite(LEDred, LOW);
        //delay(1000);
      }
      //else {
        //Serial.println("\t");
        //Serial.println(randVal);
        //Serial.println("NO DONE");
        //delay(800);
      //}
    }
   
  }
}

void myinthandler() // interrupt handler
{
  unsigned long currentMicros = micros();
  duration += currentMicros - previousMicros;
  previousMicros = currentMicros;
  pulsecount++;
}
